Package ghidra.app.services

# Record Class DebuggerEmulationService.CachedEmulator

java.lang.Object
java.lang.Record
ghidra.app.services.DebuggerEmulationService.CachedEmulator

Record Components:
  `trace` - the trace the emulator is bound to
  `emulator` - the emulator itself
  `writer` - the callbacks with delayed writes for trace/UI integration
  `version` - the cache version. See `isValid()`.

Enclosing interface:
  `DebuggerEmulationService`

public static record DebuggerEmulationService.CachedEmulator(Trace trace, PcodeMachine<?> emulator, TraceEmulationIntegration.Writer writer, long version) extends Record
An emulator managed by this service

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CachedEmulator(Trace trace, PcodeMachine<?> emulator, TraceEmulationIntegration.Writer writer)`
  `CachedEmulator(Trace trace, PcodeMachine<?> emulator, TraceEmulationIntegration.Writer writer, long version)`
  Creates an instance of a `CachedEmulator` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PcodeMachine<?>`
  `emulator()`
  Get the emulator
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `boolean`
  `isValid()`
  Check if this cached emulator is still valid
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `Trace`
  `trace()`
  Get the trace to which the emulator is bound
  `long`
  `version()`
  Returns the value of the `version` record component.
  `TraceEmulationIntegration.Writer`
  `writer()`
  Returns the value of the `writer` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CachedEmulator

    public CachedEmulator(Trace trace, PcodeMachine<?> emulator, TraceEmulationIntegration.Writer writer)

  - ### CachedEmulator

    public CachedEmulator(Trace trace, PcodeMachine<?> emulator, TraceEmulationIntegration.Writer writer, long version)
    Creates an instance of a `CachedEmulator` record class.
    Parameters:
      `trace` - the value for the `trace` record component
      `emulator` - the value for the `emulator` record component
      `writer` - the value for the `writer` record component
      `version` - the value for the `version` record component

- ## Method Details

  - ### trace

    public Trace trace()
    Get the trace to which the emulator is bound
    Returns:
      the trace

  - ### emulator

    public PcodeMachine<?> emulator()
    Get the emulator

    WARNING: This emulator belongs to this service. You may interrupt it, but stepping it, or otherwise manipulating it without the service's knowledge can lead to unintended consequences.

    Returns:
      the emulator

  - ### isValid

    public boolean isValid()
    Check if this cached emulator is still valid
    Returns:
      true if valid

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### writer

    public TraceEmulationIntegration.Writer writer()
    Returns the value of the `writer` record component.
    Returns:
      the value of the `writer` record component

  - ### version

    public long version()
    Returns the value of the `version` record component.
    Returns:
      the value of the `version` record component